<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { NextStepAlt, QuoteCarousel } from '../../components/common/index.vue';
import {
  DevExAccordion,
  DevExBenefits,
  DevExCards,
  DevExHero,
  DevExStat,
} from '../../components/developer-experience/index.vue';
import { SolutionsResourceCards } from '../../components/solutions/index.vue';
import { getPageMetadata } from '../../common/meta';
import { developerExperienceDataHelper } from '../../services/developer-experience.service';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '../../plugins/contentful.js';
import { FooterEditLinkMixin, LivePreviewMixin } from '../../mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';

export default Vue.extend({
  name: 'DeveloperExperiencePage',
  components: {
    DevExAccordion,
    DevExBenefits,
    DevExCards,
    QuoteCarousel,
    DevExHero,
    DevExStat,
    NextStepAlt,
    SolutionsResourceCards,
  },
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'developer-experience',
        include: 10,
      });
      const { pageContent, seoMetadata } = items[0].fields;
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;
      const content = developerExperienceDataHelper(pageContent, seoMetadata);
      return { content, items, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  nuxtI18n: false,
  head(): MetaInfo {
    return getPageMetadata((this as any).content, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.content = developerExperienceDataHelper(
            updatedData[0].fields.pageContent,
            updatedData[0].fields.seoMetadata,
          )),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <section class="developer-experience">
    <DevExHero :data="content.hero" />
    <DevExAccordion :data="content.accordion" />
    <DevExStat :data="content.stat" />
    <div class="gradient">
      <DevExBenefits :data="content.benefits" />
      <DevExCards
        v-for="(card, index) in content.cards"
        :key="index"
        :data="card"
      />
    </div>
    <quote-carousel v-bind="content.quotes" />
    <SolutionsResourceCards :data="content.resources" />
    <NextStepAlt />
  </section>
</template>

<style lang="scss" scoped>
.gradient {
  padding-bottom: 120px;
  background: linear-gradient(0deg, #fff, hsla(0, 0%, 100%, 0)),
    linear-gradient(100deg, #fed5db, #d7c1f2 100%);
}
</style>
